define(['durandal/http', 'durandal/app'], function (http, app) {
    
    return {
        data: ko.observableArray([]),
		buttonText: "Update!",
		labelText: "Hit the button to update the model 'desc' value of the first record with the value of 'some custom description & watch out the grid!",
		buttonClick: function () {
			// update data (the model for the IGnite Grid)
			this.data()[0].Description("some custom description");
		},
        activate: function () {
            //the router's activator calls this function and waits for it to complete before proceding
            if (this.data().length > 0) {
                return;
            }
			function Item(id, desc, productName, createdDate) {
				return {
					 id: ko.observable(id),
					 desc: ko.observable(desc),
					 productName: ko.observable(productName),
					 createdDate: ko.observable(createdDate)
				};
			};
			var myData = [
				new Item(1, "Best Italian bread", "Bread", new Date(2013, 10, 5, 1)),
				new Item(2, "Quaker oats for your taste", "Old Fashioned Quaker Oats", new Date(2012, 10, 5, 2)),
				new Item(3, "peeled and processed", "Canned tomatoes", new Date(2010, 10, 5, 2)),
				new Item(4, "The best tuna from Norway", "Canned Tuna", new Date(1999, 10, 5, 5)),
				new Item(5, "Greek olive oil", "Olive oil", new Date(2013, 10, 5, 5)),
				new Item(6, "heated beverage", "Hot chocolate", new Date(2011, 10, 5, 8)),
				new Item(7, "black beans from Guatemala", "Beans", new Date(2005, 10, 5, 6)),
				new Item(8, "Green Equador bananas", "Bananas", new Date(2004, 10, 5, 5)),
				new Item(9, "raw avocado", "Avocados", new Date(2004, 10, 5, 5)),
				new Item(10, "brown sugar from the Netherlands", "Brown sugar", new Date(2013, 10, 5, 4)),
				new Item(11, "Peru 100% cocoa", "Cocoa", new Date(2013, 10, 5, 4)),
				new Item(12, "Bulgarian natural honey", "Honey", new Date(2012, 10, 5, 9)),
				new Item(13, "Brought to you by Heinz", "Apple cider vinegar", new Date(1994, 10, 5, 7)),
				new Item(14, "grass-fed", "Boneless chicken breast", new Date(1998, 10, 2, 7)),
				new Item(15, "Salmon from Scotland", "Salmon", new Date(2013, 2, 5, 8)),
				new Item(16, "Uruguay's best ribeye steaks", "Ribeye steaks", new Date(2013, 3, 5, 8)),
				new Item(17, "turkey lean meat", "Ground turkey", new Date(2013, 4, 5, 11)),
				new Item(18, "fresh bio lettuce", "Lettuce", new Date(2013, 7, 5, 11)),
				new Item(19, "Pami peanut butter", "Peanut Butter", new Date(2014, 7, 3, 2)),
				new Item(20, "Fresh Asparagus", "Asparagus", new Date(2013, 10, 2, 1)),
				new Item(21, "raw almonds, non salted", "Almonds", new Date(2009, 8, 5, 1)),
				new Item(22, "White feta cheese", "White cheese", new Date(2013, 10, 5, 3)),
				new Item(23, "hot peppers", "Black peppers", new Date(2013, 10, 5, 6)),
				new Item(24, "baked and salted pumpkin seeds", "Pumpkin seeds", new Date(2013, 10, 5, 5))
			];
            return this.data(myData);
        },
        canDeactivate: function () {
            //the router's activator calls this function to see if it can leave the screen
            return app.showMessage('Are you sure you want to leave this page?', 'Navigate', ['Yes', 'No']);
        }
    };
});